﻿using System.Threading;
using System.Windows;

namespace BackgroundWorkerInWPF
{
    /// <summary>
    /// Interaction logic for WorkerWindow.xaml
    /// </summary>
    public partial class WorkerWindow : Window
    {
        public WorkerWindow()
        {
            InitializeComponent();
        }

        #region Long-Running Process

        private int DoSlowProcess(int iterations)
        {
            int result = 0;

            for (int i = 1; i <= iterations; i++)
            {
                Thread.Sleep(100);
                result = i;
            }

            return result;
        }

        #endregion

        #region UI Events

        private void startButton_Click(object sender, RoutedEventArgs e)
        {
            int iterations = 0;
            if (int.TryParse(inputBox.Text, out iterations))
            {
                outputBox.Text = DoSlowProcess(iterations).ToString();
                startButton.IsEnabled = true;
                cancelButton.IsEnabled = false;
            }
        }

        private void cancelButton_Click(object sender, RoutedEventArgs e)
        {
            // TODO: Implement Cancel Process
        }

        #endregion
    }
}
